import { ObjectState } from './object-state';
import { IBuildable, ICleanable, IResetable } from './types';
export declare class CollectionState<T> implements ICleanable, IResetable, IBuildable<T[]> {
    private _elements;
    constructor(elements: T[]);
    get elements(): ObjectState<T>[];
    get dirtyElements(): ObjectState<T>[];
    get count(): number;
    get(index: 0): ObjectState<T>;
    add(element: T): void;
    clean(): void;
    reset(): void;
    build(): T[];
}
