import { IBuildable, ICleanable, IResetable, IState } from './types';
export declare class PropertyState<TValue> implements IState, IBuildable<TValue>, ICleanable, IResetable {
    private _key;
    private _value;
    private _original;
    get key(): string;
    get value(): TValue;
    set value(value: TValue);
    get isDirty(): boolean;
    constructor(key: string, value: TValue);
    reset(value?: TValue): void;
    build(): TValue;
    clean(): void;
    private getResetValue;
}
